#include "incoming.h"
#include "platform.h"

#include <system_error>

CIncoming::CIncoming(int port) : mPort(port) {

	mSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	sockaddr_in serverAddr = { 0 };
	serverAddr.sin_family = AF_INET;
	serverAddr.sin_addr.s_addr= INADDR_ANY;
	serverAddr.sin_port = htons(mPort);

	if ((mSocket == INVALID_SOCKET) || (bind(mSocket, (sockaddr *)&serverAddr, sizeof(serverAddr)) == SOCKET_ERROR)) {
		ThrowLastSystemError();
	}

	if (listen(mSocket, SOMAXCONN) == SOCKET_ERROR) {
		ThrowLastSystemError();
	}
	
}

CIncoming::~CIncoming() {
	Stop();
}

void CIncoming::Recieve() {

		
	sockaddr_in clientAddr;
	socklen_t len = sizeof(clientAddr);

	SOCKET client = accept(mSocket, (sockaddr *)&clientAddr, &len);

	if (client == INVALID_SOCKET)
		printf("zastaveno\n");
	else
		printf("prijato\n");

	closesocket(client);
}

void CIncoming::Stop() {
	if (mSocket != INVALID_SOCKET) {
		closesocket(mSocket);
		mSocket = INVALID_SOCKET;
	}
}