#include "platform.h"

#include <system_error>

const CNetStack netStackHelper;

CNetStack::CNetStack() {
#ifdef _WIN32
	WSADATA wsaData;
	if (WSAStartup(MAKEWORD(2, 2), &wsaData) != NO_ERROR) {
		ThrowLastSystemError();
	}
#endif
}

CNetStack::~CNetStack() {
#ifdef _WIN32
	WSACleanup();
#endif
}

void ThrowLastSystemError() {
	std::error_code ec(errno, std::system_category());
	throw std::system_error(ec, ec.message());
}